;|
LISP-   MtmdAcadTabs
        MtmdAcadTabs.arx

     
  (mtmdsettabtext _)
 (mtmdsettabtext (getvar "DWGNAME"))
      
 "mtmdsettabfn" (. )

   SetTabTextfromDB,  
""   SQL-  .
,        

|;

;    :
(mtmdaddtabmenuitem "" "_QSAVE\n")
(mtmdaddtabmenuitem "" "_CLOSE\n")
;----------------------------------
;  
;----------------------------------
(vl-load-com)
(defun ado-getfield(fields fieldname)
  (vlax-variant-value (adop-get-Value (adop-get-Item fields (vlax-make-variant fieldname))))
);defun
;----------------------------------
;  ADO 
;     
;----------------------------------
(defun pdmInitADO()
	(if (equal nil adoc-adOpenDynamic) ; check for a ADO constant
    (vlax-import-type-library
      :tlb-filename "C:/Program Files/Common Files/System/ado/msado15.dll"
      :methods-prefix "adom-"
      :properties-prefix "adop-"
      :constants-prefix "adoc-"
    ) 
  )
);defun


(defun SetTabTextfromDB( / path fname docfname res flds connstr strsql query fnamebase filever)
  (setq fname (getvar "DWGNAME"))
	(if (= (getvar "DWGPREFIX") "F:\\PDM\\")
		(progn
		    (setq fnamebase (vl-filename-base fname))
		    (setq filever (substr fnamebase (1- (strlen fnamebase)) 2))
		    (setq docfname 
		      (strcat
		        (substr fnamebase 1 (- (strlen fnamebase) 2))
		        (vl-filename-extension fname)
		      )
		    )
		    
		    (pdmInitADO)
		    (setq connstr "Provider=MSDASQL.1;Password=sql;Persist Security Info=True;User ID=dba;Data Source=PDM")
		    (setq connstr (vlax-make-variant connstr))
		    (setq strsql (strcat "select description from File_V where file_name = '" docfname "'"))
			  
		;    (pdmdebugprint strsql)
		;    (princ strsql)
		    (setq strsql (vlax-make-variant strsql))
		    (setq query (vlax-create-object "ADODB.Recordset"))
		    (adom-Open query strsql connstr -1 -1 -1)
		    (setq flds (adop-get-Fields query))

				(mtmdsettabtext (strcat (ado-getfield flds "description") " #" filever 
				  (if (= (getvar "WRITESTAT") 0) " [RO]" "")
				))

		    (vlax-release-object flds)
		    (vlax-release-object query)
		    (setq query nil)
		  );progn
			(mtmdsettabtext (strcat (getvar "DWGNAME") (if (= (getvar "WRITESTAT") 0) " [RO]" "")))
	  );if
)
;----------------------------------
;     
;----------------------------------
(defun mtmdsettabfn()
;	(acad-push-dbmod)
	(mtmdsettabtext (strcat (getvar "DWGNAME") (if (= (getvar "WRITESTAT") 0) " [RO]" "")))
;	(SetTabTextfromDB)
;	(acad-pop-dbmod)
)

;----------------------------------
;  
;          
;----------------------------------
(defun mtmdtabssavefn (calling-reactor commandInfo / dwg)
  (setq dwg (cadr commandInfo))
  (if (and (/= (getvar "cmdnames") "") (/= dwg mtmdtabdwgname))
  	(progn
;			(princ (strcat "\n" dwg "\n"))
			(mtmdsettabfn)
			(setq mtmdtabdwgname dwg)
		)
	)
)
;------------------------
(setq mtmdtabdwgname "")


(defun mtmdtabclosefn (calling-reactor commandInfo)
	(vlr-remove *mtmdtabcloseReac*) 
	(vlr-remove *mtmdtabsaveReac*) 
	(setq *mtmdtabsaveReac* nil)
	(setq *mtmdtabcloseReac* nil)
);defun

(if (not *mtmdtabcloseReac*) (setq *mtmdtabcloseReac* (vlr-dwg-Reactor nil '((:vlr-beginClose . mtmdtabclosefn)))))
(if (not *mtmdtabsaveReac*) (setq *mtmdtabsaveReac* (vlr-dwg-Reactor nil '((:vlr-saveComplete . mtmdtabssavefn)))))

(mtmdsettabfn)


(princ "\nMtmdAcadTabs.lsp loaded")
(princ)
