;;; -----------------------------------------------------------------
;;; (c) Franz Ploetzl Ottensheim/Donau/Austria
;;; franz@ploetzl.at http://www.ploetzl.at/tools
;;; A-4100 Ottensheim Holzweg 5 tel +43 (0)732 771250 16 fax 12
;;; A-1050 Wien Hartmanngassse 13/4/36 tel +43 (0)1     5456702
;;; -----------------------------------------------------------------
;;; SCHOIDSTE.LSP dieses file
;;; SCHODISTE.DCL dcl dialog
;;; SCHODISTE.INI ini file --> benutzereinstellungen
;;
;;  Treppenlauf im Schnitt darstellen
;;
;;  Pkazy: SCHOD
;;;
;;; rel11/0.1 0291pf
;;; rel11/1.0 0992pf 
;;; rel12/13/1.1 0995pf dcl dialog
;;; rel12/13/14/15/1.2 0101pf bug ini file laden beseitigt
;;; -----------------------------------------------------------------
;;; platformen getestet:
;;; win2000, autocad 15
;;; -----------------------------------------------------------------
;;;
;;; License Agreement
;;;  -----------------
;;; Diese Programme sind dem OpenSourceKonzept verschrieben.
;;; Was mit den Programmen, ausser dem Benutzen selbst, erlaubt ist:
;;; Weitergeben an Dritte, uneingeschrnkte Modifikation des Quelltextes
;;; (SourceCode) bzw. Weiterverwendung von Teilen oder des gesamten
;;; Quelltextets in Software Dritter unter Einhaltung des 'CopyLefts'.

;;; Permission to use, copy, and distribute this software for any purpose
;;; and without fee is hereby granted, provided that the above copyright
;;; notice appears in all copies and that both that copyright notice and
;;; this permission notice appear in all supporting documentation.
;;; Franz Pltzl makes no warranty, including but not limited to any implied
;;; warranties of merchantability or fitness for a particular purpose,
;;; regarding the software and accompanying materials. The software and
;;; accompanying materials are provided solely on an 'as-is' basis.
;;; In no event Franz Pltzl will be liable to any special, collateral,
;;; incidental, or consequential damages in connection with or arising out
;;; of the use of the software or accompanying materials.
   
;;; Einen Einschrnkung gibt es doch:
;;; Ganz umsonst mchte ich unsere TOOLS nicht hergeben.
;;; Wenn Sie mit einem Programm von uns zufrieden sind und dieses auch
;;; in Ihrem Betrieb, Unternehmen, etc. einsetzen, sind Sie verpflichtet,
;;; fr jedes Tool einen angemessenen Betrag
;;; (von 100 bis 500 ATS / 15 bis 70 DM / 10 bis 50 $ oder auch mehr)
;;; fr 'Soziale Projekte' oder 'Einrichtungen' zu spenden!
;;; 
;;; BUT
;;; If one of our tools helps you working please spend 
;;; 100ATS/15DM/10$ --> 500ATS/70DM/50$ for handicaped people.
;;;  
;;; -----------------------------------------------------------------
;;;  Thanks for using franz@ploetzl.at.
;;; -----------------------------------------------------------------
;;;
;;;--------------------------------------------------------
;;; ERROR.LSP  error handling 
;;;            save and resrtore variables 
;;;--------------------------------------------------------
;; fehlerroutine small
;; pf 0693 ver 12c1/0.1
;; pf 0695 ver 12/13/0.2 liste
;; pf 0895 ver 12/13/1.0 undo beginn/end
;;--------------------------------------------------------
(defun apf_f:error (msg)
  (if (/= msg "Funkce zruena" )
    (prompt (strcat "\nAPF_Fehler:  " msg))
    (prompt "\nAPF_Fehler:  Abbruch Programm/Benutzer." )
  ) 
  (setq *error* apf_v:oerror)
  (apf_f:error_r)
  (princ)
)
;; error save
;; apf_f:error_s (list "cmdecho" "blipmode"))
;; apf_f:error_s (nil)

(defun apf_f:error_s (liste) 

 (setq apf_v:oerrl nil
       apf_v:olay (getvar "clayer")
       ocmd (getvar "cmdecho") 
 )
 (setvar "cmdecho" 0)
 (command "_.undo" "_be") 
 (if (tblsearch "UCS" "APF_UCS") (command "_.ucs" "_del" "apf_ucs"))
 (command "_.ucs" "_save" "apf_ucs")

 (repeat (length liste)
   (setq du (car liste)
         apf_v:oerrl 
           (cons 
             (list du (getvar du)) 
             apf_v:oerrl
           )
         liste (cdr liste)
   )
 )
 (setq apf_v:oerror *error* 
       *error* apf_f:error
 )
)
;;
;; error restore
;;
(defun apf_f:error_r (/ lis var val)

  (setvar "clayer" apf_v:olay) 
  (repeat (length apf_v:oerrl)
    (setq lis (car apf_v:oerrl)
          var (car lis)
          val (cadr lis)
          apf_v:oerrl (cdr apf_v:oerrl)
    )
    (setvar var val)
  )
  (setq *error* apf_v:oerror)
  (setvar "cmdecho" 0) 
  (command "_.ucs" "_restore" "apf_ucs")
  (command "_.ucs" "_del" "apf_ucs")
  (command "_.undo" "_e") 
  (setvar "cmdecho" ocmd)
  (princ)
)

;;--------------------------------------------------------
;; SCHODIT
;;--------------------------------------------------------
;;nur zum progr.
(defun c:ls () (load"schodiste")(c:schod))
;;rel
(setq st:rel "rel.1.2.01.01.pf")
;;
;; main
;;
(defun c:schod () (c:apf_f:schod))
(defun c:apf_f:schod (/ file)

  (apf_f:error_s (list "cmdecho" "osmode" "blipmode" "luprec")) 
  (if (not st:b)
    (if (setq file (findfile "schodiste.ini"))
      (load file)
      (setq st:b  "0.270"
            st:h  "0.180"
            st:an "20"
      )
    )
  )
  (if (<= (getvar "luprec") 4) (setvar "luprec" 4))
  (setq st:u (getvar "lunits")
        st:d (getvar "luprec")
  )
  (st_dcl) 
  (apf_f:error_r) 

)
;
;; up dcl 
;
(defun st_dcl ( / pt1 pt2 pt3 pt4 x y file st_dialog done)

; variablen init
 
;dcl dialog
  (setq file (findfile "schodiste.dcl"))
  (setq st_dialog (load_dialog file))
  (if st_dialog (new_dialog "schodiste" st_dialog)(exit))
; slide
   (setq x (dimx_tile "slide")
         y (dimy_tile "slide")
   )
   (start_image "slide")
     (fill_image 0 0 x y 0) 
     (slide_image 0 0 x y "schodiste")
   (end_image)
;set_tile werte zuweisen
   (st_dcl_b st:b)
   (st_dcl_h st:h)   
;   (set_tile "b" st:b)
;   (set_tile "h" st:h)
   (set_tile "anz" st:an)
   (st_2hb)
   (st_win)
;mode_tile
   (mode_tile "slide" 1)   
   (mode_tile "w" 1)
   (mode_tile "2hb" 1)
;action_tile
   (action_tile "b"       "(st_dcl_b  $VALUE)")
   (action_tile "h"       "(st_dcl_h  $VALUE)")
   (action_tile "l"       "(st_dcl_l  $VALUE)")
   (action_tile "H"       "(st_dcl_hg $VALUE)")
   (action_tile "anz"     "(st_dcl_an $VALUE)")
   (action_tile "w"       "(setq w $VALUE)")
   (action_tile "2hb"     "(setq sum $VALUE)")
   (action_tile "help"    "(st_dcl_info)")  
   (action_tile "chancel" "(done_dialog 0)")
   (action_tile "accept"  "(done_dialog 1)")
   
   (setq done (start_dialog))
   (unload_dialog st_dialog)

   (cond
     ((= done 1)
       (while (= (setq pt1 (getpoint "\nBod vloen: ")) nil))
       (setvar "osmode" 0)
       (setvar "cmdecho" 0) 
       (setvar "blipmode" 0)
       (command "_.PLINE")
       (repeat (atoi st:an)
         (setq pt2 (polar pt1 (/ pi 2) (atof st:h)))
         (setq pt3 (polar pt2 0  (atof st:b)))
         (command pt1 pt2 pt3)
         (setq pt1 pt3)  
       );repeat
       (command "")
     );done 1
     ((= done 0) 
       (princ "\nNic k proveden.")
     );done 0
   );cond


   (princ)

);defun
;;
;; 2*h+b
;;
(defun st_2hb ()
  (set_tile "2hb" (setq st:2hb (rtos (+ (* 2.0 (atof st:h)) (atof st:b)))))
)
;;
;; winkel
;;
(defun st_win ()
  (setq p2    (polar (polar (list 0 0) 0 (atof st:b)) (/ pi 2.0) (atof st:h))
        st:wi (rtos (/ (* (angle (list 0 0) p2) 180.0) pi))
  )
  (set_tile "w" st:wi)
)
;;
;;st_dcl_h
;;
(defun st_dcl_h (value)
  (set_tile "h" (setq st:h (st_dcl_ch value st:h)))
  (set_tile "H" (setq st:hg (rtos (* (atof st:an) (atof st:h)))))
  (st_win)
  (st_2hb) 
)
;;
;;st_dcl_hg
;;
(defun st_dcl_hg (value)
  (set_tile "H" (setq st:hg (st_dcl_ch value st:hg)))
  (set_tile "h" (setq st:h (rtos (/ (atof st:hg) (atof st:an)))))
  (st_win)
  (st_2hb) 
)
;;
;;st_dcl_b
;;
(defun st_dcl_b (value)
  (set_tile "b" (setq st:b (st_dcl_ch value st:b)))
  (set_tile "l" (setq st:l (rtos (* (atof st:b) (atof st:an)))))
  (st_win)
  (st_2hb)
)
;;
;;st_dcl_L
;;
(defun st_dcl_l (value)
  (set_tile "l" (setq st:l (st_dcl_ch value st:l)))
  (set_tile "b" (setq st:b (rtos (/ (atof st:l) (atof st:an)))))
  (st_win)
  (st_2hb)
)
;;
;;st_dcl_an
;;
(defun st_dcl_an (value)
  (set_tile "anz" (setq st:an (rtos (atof (st_dcl_ch value st:an)) st:u 0)))
  (set_tile "l" (setq st:l (rtos (* (atof st:b) (atof st:an)))))
  (set_tile "H" (setq st:hg (rtos (* (atof st:an) (atof st:h)))))
  (st_win)
  (st_2hb)
)
;;
;; st_dcl_ch
;;
(defun st_dcl_ch (check old)
  (if (<= (atof check) 0)
    (progn
      (alert "Neplatn hodnota:\nHodnota mus bt > 0!")
      (setq check old)
    )
    (setq check (rtos (atof check)))
  );if         
)
;;;
;;; info 
;;;
(defun st_dcl_info () 
   (setq _dialog (load_dialog "schodiste"))
   (if _dialog (new_dialog "info" _dialog)
     (progn 
       (alert (strcat "Kann Dialog " _dialog " nicht initialisieren!"))(exit)
     );progn
   );if 

   (set_tile "text1" (strcat "acad_pf - SCHODISTE.LSP - " st:rel))
   (set_tile "text2" "")
   (set_tile "text3" (strcat (getvar "platform") " " (getvar "acadver") " "(getvar "_pkser")))
   (set_tile "text4" "(c) Franz Ploetzl, Ottensheim/Linz/Vienna - Austria")
   (set_tile "text5" "franz@ploetzl.at www.ploetzl.at/tools") 

   (setq x (dimx_tile "slidei")
         y (dimy_tile "slidei")
   )
   (start_image "slidei")
   (fill_image 0 0 x y 0) 
   (slide_image 0 0 x y "acad_pf")
   (end_image)
   (start_list "list") 
   (mapcar 
     (quote add_list) 
       (list "  SCHODIT (STEIGUNG)"
             ""
             "  Utilita uren pro rychl vytvoen ezovho schema schodit."
             "  Schema je vytvoeno  pomoc kivky."
             "  Rozmry je nutn zadvat v [mm]."
             ""
             "  SCHODISTE.LSP dieses file"
             "  SCHODISTE.DCL dcl dialog"
             "  SCHODISTE.INI ini soubor --> vchoz nastaven"
             ""
             "  PKAZ: SCHOD"
             ""
             "  rel11/0.1 0291pf"
             "  rel11/1.0 0992pf "
             "  rel12/13/1.1 0995pf dcl dialog"
             "  rel12/13/14/15/1.2 0101pf bug ini file laden beseitigt"
             ""
             "  License Agreement"
             "  -----------------"
             "  Diese Programme sind dem OpenSourceKonzept verschrieben."
             "  Was mit den Programmen, ausser dem Benutzen selbst, erlaubt ist:"
             "  Weitergeben an Dritte, uneingeschrnkte Modifikation des Quelltextes"
             "  (SourceCode) bzw. Weiterverwendung von Teilen oder des gesamten"
             "  Quelltextets in Software Dritter unter Einhaltung des 'CopyLefts'."
             ""
             "  Permission to use, copy, and distribute this software for any purpose"
             "  and without fee is hereby granted, provided that the above copyright"
             "  notice appears in all copies and that both that copyright notice and"
             "  this permission notice appear in all supporting documentation."
             "  Franz Pltzl makes no warranty, including but not limited to any implied"
             "  warranties of merchantability or fitness for a particular purpose,"
             "  regarding the software and accompanying materials. The software and"
             "  accompanying materials are provided solely on an 'as-is' basis."
             "  In no event Franz Pltzl will be liable to any special, collateral,"
             "  incidental, or consequential damages in connection with or arising out"
             "  of the use of the software or accompanying materials."
             "" 
             "  Einen Einschrnkung gibt es doch:"
             "  Ganz umsonst mchte ich unsere TOOLS nicht hergeben."
             "  Wenn Sie mit einem Programm von uns zufrieden sind und dieses auch"
             "  in Ihrem Betrieb, Unternehmen, etc. einsetzen, sind Sie verpflichtet,"
             "  fr jedes Tool einen angemessenen Betrag"
             "  (von 100 bis 500 ATS / 15 bis 70 DM / 10 bis 50 $ oder auch mehr)"
             "  fr 'Soziale Projekte' oder 'Einrichtungen' zu spenden!"
             ""
             "  BUT"
             "  If one of our tools helps you working please spend "
             "  100ATS/15DM/10$ --> 500ATS/70DM/50$ for handicaped people."
             ""
             "  thanks for using. franz@ploetzl.at www.ploetzl.at/tools" 
       )
   ) 
   (end_list) 
   (action_tile "accept" "(done_dialog 1)") 
   (start_dialog)
  
)

(prompt (strcat "\nSchodiste.lsp byl spn naten. Nstroj spustte pkazem SCHOD. " st:rel))
(princ)

