;=========================================================================
; VlozBlok.lsp    Vloit blok s atributem
; (c) Copyright 2007 Pepa
; Version:   1.1
;-------------------------------------------------------------------------
; Description:
;
; Vlo blok do hladiny "KOTY" nebo "POPIS" s monost nastaven atribut.
;
; Command options:
;  "POPISD"      Vlo popis dve
;  "POPISDPO"    Vlo popis pornch dve
;  "BUBL"        Vlo bublinu
;  "BUBLK"       Vlo bublinu K
;  "BUBLOP"      Vlo bublinu OP
;  "BUBLP"       Vlo bublinu P
;  "BUBLPL"      Vlo bublinu PL
;  "BUBLPO"      Vlo bublinu PO
;  "BUBLT"       Vlo bublinu T
;  "BUBLZ"       Vlo bublinu Z
;  "VKRAM"       Vlo vkovou ktu v rmeku
;  "VKZAKLA"      Vlo vkovou ktu zkladu
;  "VKZAKLB"      Vlo vkovou ktu zkladu
;  "PTUTP"       Vlo vkovou ktu ternu
;  "PTUTL"       Vlo vkovou ktu ternu
;  "VKBOD"       Vlo vkovou ktu bodu
;  "SPADL"       Vlo spd (lev)
;  "SPADP"       Vlo spd (lev)
;  "SCHODKOLECKO" Vlo schodiov koleko
;  "SCHODSIPKA"  Vlo schodiovou ipku
;  "VSTUP"       Vlo znaku vstupu
;  "CMISTNOSTI"  Vlo slo mstnosti
;  "REZL"        Vlo oznaen ezu (lev)
;  "REZP"        Vlo oznaen ezu (prav)
;  "SEVERKA"     Vlo severku
;
;============================================================================
; nastaven vkldn do hladiny "KOTY"
;============================================================================
(defun vloz_koty-start ()
  (setq body nil)
  (setq echo (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq olderr *error*)
  (setq *error* k-err)
  (setq vych_hlad (getvar "CLAYER"))
  (if (= (setq barva (getvar "CECOLOR")) "BYLAYER")
           (setq barva "BYLAYER")
  )
  (if (= (setq vych_cara (getvar "CELTYPE")) "BYLAYER")
            (setq vych_cara "BYLAYER")
  )
  (if (not (tblsearch "layer" "KOTY"))
    (progn
      (command "_LAYER" "_Make" "KOTY" "_Color" "4" "KOTY" "")
      (prompt "\nVytvoena hladina KOTY - barva 4 (svtle modr).")
    ) ; progn
  ) ; if
  (command "_LAYER" "_S" "KOTY" ""
           "_COLOR" "_BYLAYER"
           "_LINETYPE" "_S" "_BYLAYER" ""
  )
  (setq vych_nast (getvar "ATTREQ"))
  (setvar "ATTREQ" 0)
  (setq attd (getvar "ATTDIA"))
  (setvar "ATTDIA" 0)
)

(defun vloz_koty-end ()
  (if body (vymaz_body))
  (setq *error* olderr olderr nil)
  (command "_LAYER" "_S" vych_hlad ""
           "_COLOR" barva
           "_LINETYPE" "_S" vych_cara ""
  ) ; command
  (setvar "ATTREQ" vych_nast)
  (setvar "ATTDIA" attd)
  (setvar "cmdecho" echo)
  (princ)
)
;============================================================================
; nastaven vkldn do hladiny "POPIS"
;============================================================================
(defun vloz_popis-start ()
  (setq body nil)
  (setq echo (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq olderr *error*)
  (setq *error* k-err)
  (setq vych_hlad (getvar "CLAYER"))
  (if (= (setq barva (getvar "CECOLOR")) "BYLAYER")
           (setq barva "BYLAYER")
  )
  (if (= (setq vych_cara (getvar "CELTYPE")) "BYLAYER")
            (setq vych_cara "BYLAYER")
  )
  (if (not (tblsearch "layer" "POPIS"))
    (progn
      (command "_LAYER" "_Make" "POPIS" "_Color" "5" "POPIS" "")
      (prompt "\nVytvoena hladina POPIS - barva 5 (modr).")
    ) ; progn
  ) ; if
  (command "_LAYER" "_S" "POPIS" ""
           "_COLOR" "_BYLAYER"
           "_LINETYPE" "_S" "_BYLAYER" ""
  )
  (setq vych_nast (getvar "ATTREQ"))
  (setvar "ATTREQ" 0)
  (setq attd (getvar "ATTDIA"))
  (setvar "ATTDIA" 0)
)

(defun vloz_popis-end ()
  (if body (vymaz_body))
  (setq *error* olderr olderr nil)
  (command "_LAYER" "_S" vych_hlad ""
           "_COLOR" barva
           "_LINETYPE" "_S" vych_cara ""
  ) ; command
  (setvar "ATTREQ" vych_nast)
  (setvar "ATTDIA" attd)
  (setvar "cmdecho" echo)
  (princ)
)
;============================================================================
; nastaven vkldn do hladiny "PSV"
;============================================================================
(defun vloz_psv-start ()
  (setq body nil)
  (setq echo (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq olderr *error*)
  (setq *error* k-err)
  (setq vych_hlad (getvar "CLAYER"))
  (if (= (setq barva (getvar "CECOLOR")) "BYLAYER")
           (setq barva "BYLAYER")
  )
  (if (= (setq vych_cara (getvar "CELTYPE")) "BYLAYER")
            (setq vych_cara "BYLAYER")
  )
  (if (not (tblsearch "layer" "PSV"))
    (progn
      (command "_LAYER" "_Make" "PSV" "_Color" "5" "PSV" "")
      (prompt "\nVytvoena hladina PSV - barva 5 (modr).")
    ) ; progn
  ) ; if
  (command "_LAYER" "_S" "PSV" ""
           "_COLOR" "_BYLAYER"
           "_LINETYPE" "_S" "_BYLAYER" ""
  )
  (setq vych_nast (getvar "ATTREQ"))
  (setvar "ATTREQ" 0)
  (setq attd (getvar "ATTDIA"))
  (setvar "ATTDIA" 0)
)

(defun vloz_psv-end ()
  (if body (vymaz_body))
  (setq *error* olderr olderr nil)
  (command "_LAYER" "_S" vych_hlad ""
           "_COLOR" barva
           "_LINETYPE" "_S" vych_cara ""
  ) ; command
  (setvar "ATTREQ" vych_nast)
  (setvar "ATTDIA" attd)
  (setvar "cmdecho" echo)
  (princ)
)
;============================================================================
; Vlo blok s popisem dve
;============================================================================
(defun C:POPISD ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen popisu dve :")
  (command "_-INSERT" "Rozmer_Dvere" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok s popisem pornch dve
;============================================================================
(defun C:POPISDPO ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen popisu dve :")
  (command "_-INSERT" "Rozmer_Dvere_PO" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok bubliny
;============================================================================
(defun C:BUBL ()
  (vloz_psv-start)
  (prompt "\nUrete bod vloen bubliny :")
  (command "_-INSERT" "Bublina" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok bubliny K
;============================================================================
(defun C:BUBLK ()
  (vloz_psv-start)
  (prompt "\nUrete bod vloen bubliny :")
  (command "_-INSERT" "Bublina_K" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_psv-end)
)
;============================================================================
; Vlo blok bubliny OP
;============================================================================
(defun C:BUBLOP ()
  (vloz_psv-start)
  (prompt "\nUrete bod vloen bubliny :")
  (command "_-INSERT" "Bublina_OP" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_psv-end)
)
;============================================================================
; Vlo blok bubliny P
;============================================================================
(defun C:BUBLP ()
  (vloz_psv-start)
  (prompt "\nUrete bod vloen bubliny :")
  (command "_-INSERT" "Bublina_P" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_psv-end)
)
;============================================================================
; Vlo blok bubliny PL
;============================================================================
(defun C:BUBLPL ()
  (vloz_psv-start)
  (prompt "\nUrete bod vloen bubliny :")
  (command "_-INSERT" "Bublina_PL" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_psv-end)
)
;============================================================================
; Vlo blok bubliny PO
;============================================================================
(defun C:BUBLPO ()
  (vloz_psv-start)
  (prompt "\nUrete bod vloen bubliny :")
  (command "_-INSERT" "Bublina_PO" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_psv-end)
)
;============================================================================
; Vlo blok bubliny T
;============================================================================
(defun C:BUBLT ()
  (vloz_psv-start)
  (prompt "\nUrete bod vloen bubliny :")
  (command "_-INSERT" "Bublina_T" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_psv-end)
)
;============================================================================
; Vlo blok bubliny Z
;============================================================================
(defun C:BUBLZ ()
  (vloz_psv-start)
  (prompt "\nUrete bod vloen bubliny :")
  (command "_-INSERT" "Bublina_Z" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_psv-end)
)
;============================================================================
; Vlo blok vkov kty v rmeku
;============================================================================
(defun C:VKRAM ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen vkov kty :")
  (command "_-INSERT" "Vyska_Pudorys" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok vkov kty zkladu A
;============================================================================
(defun C:VKZAKLA ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen vkov kty :")
  (command "_-INSERT" "Vyska_Zaklad_A" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok vkov kty zkladu B
;============================================================================
(defun C:VKZAKLB ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen vkov kty :")
  (command "_-INSERT" "Vyska_Zaklad_B" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo vkovou ktu ternu (lev)
;============================================================================
(defun C:PTUTP ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen vkov kty ternu :")
  (command "_-INSERT" "PTUT_P" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo vkovou ktu ternu (lev)
;============================================================================
(defun C:PTUTL ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen vkov kty ternu :")
  (command "_-INSERT" "PTUT_L" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok vkovoivoi ktu bodu
;============================================================================
(defun C:VKBOD ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen vkov kty bodu :")
  (command "_-INSERT" "Vyska_Bod" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok spdu (lev)
;============================================================================
(defun C:SPADL ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen spdu :")
  (command "_-INSERT" "Spad_L" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok spdu (prav)
;============================================================================
(defun C:SPADP ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen spdu :")
  (command "_-INSERT" "Spad_P" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok schodiovho koleka
;============================================================================
(defun C:SCHODKOLECKO ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen koleka :")
  (command "_-INSERT" "Schod_kolecko" pause "1" "1" pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok schodiov ipky
;============================================================================
(defun C:SCHODSIPKA ()
  (vloz_koty-start)
  (prompt "\nUrete bod vloen ipky :")
  (command "_-INSERT" "Schod_sipka" pause "1" "1" pause)
  (vloz_koty-end)
)
;============================================================================
; Vlo blok oznaen vstupu
;============================================================================
(defun C:VSTUP ()
  (vloz_popis-start)
  (prompt "\nUrete bod vloen znaky vstupu :")
  (command "_-INSERT" "Vstup" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_popis-end)
)
;============================================================================
; Vlo blok s oznaenm slem mstnosti
;============================================================================
(defun C:CMISTNOSTI ()
  (vloz_popis-start)
  (prompt "\nUrete bod vloen sla mstnosti :")
  (command "_-INSERT" "Cislo_mistnosti" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_popis-end)
)
;============================================================================
; Vlo blok s oznaenm ezu (lev)
;============================================================================
(defun C:REZL ()
  (vloz_popis-start)
  (prompt "\nUrete bod vloen oznaen ezu :")
  (command "_-INSERT" "Rez_Levy" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_popis-end)
)
;============================================================================
; Vlo blok s oznaenm ezu (prav)
;============================================================================
(defun C:REZP ()
  (vloz_popis-start)
  (prompt "\nUrete bod vloen oznaen ezu :")
  (command "_-INSERT" "Rez_Pravy" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_popis-end)
)
;============================================================================
; Vlo blok severky
;============================================================================
(defun C:SEVERKA ()
  (vloz_popis-start)
  (prompt "\nUrete bod vloen severky :")
  (command "_-INSERT" "Severka" pause (getvar "dimscale")(getvar "dimscale") pause)
  (vloz_popis-end)
)
