;---------------------------------------------------------------------------------
;		FUNKCE KOTAUCS - OTO KTOVAC TEXTY DLE AKTULNHO UCS
;---------------------------------------------------------------------------------
;Funkce provede modifikaci kt do aktulnho USS 
;(v ppad kt natoench pi vkldn bloku)

;lokln promnn	SG	vbrov mnoina
;			I	pomocn - poad entity v mnoin, poet upravench entit
;			EN	jmno entity
;			ED	data entity
;			ND	nov data entity
;			SMER	horizontln smr ktovac entity

;---------------------------------------------------------------------------------	

(defun C:KOTAUCS ( / SMER SG I EN ED ND )
	(command "_undo" "_m")
	(setq SMER (- (* PI 2)(angle '(0 0 0)(getvar "ucsxdir"))))
	(terpri)
	(prompt "\n Vyber kty pro jejich modifikace do aktulnho USS : ")
	(setq SG (ssget '((0 . "DIMENSION"))))
	(prompt "\nModifikuji vybran objekty ... ")
	(setq I 0)
	(repeat (sslength SG)
		(setq ED (entget (setq EN (ssname SG I))))
		(setq ND (subst (cons 51 SMER) (assoc 51 ED) ED))
		(entmod ND)
		(entupd EN)
		(setq I (+ 1 I))
	)
	(prompt "hotovo. \n")
	(princ I)
	(prompt " entit typu DIMENSION (KTA) upraveno ")
	(princ)
)


;************************************************************************

;  		zatek sekvence programu na pravu kt

;************************************************************************



;************************  podfunkce KOTA_J a KOTA_B		

(defun PDIM_ZAOK (c r / x p)
	(setq x 1)
	(repeat r (setq x (* 10 x)))
	(if (= (type c) 'LIST)
		(foreach p c
			(setq c (subst (/ (float (fix (* p x))) x) p c))
		)
		(/ (float (fix (* c x))) x)
	)
)

;----------------------------------------------------------------------------------------

;***************** FUNKCE KOTA_B  (ROZDL STVAJC KTU NA DV) ***********************

;----------------------------------------------------------------------------------------

(defun C:KOTA_B ( / DECHO e d10 d13 d14 a TYP SMER bod bodxx bod2 cl B K ND)  
	(command "_undo" "_m")
	(setq DECHO (getvar "CMDECHO"))
	(setvar "CMDECHO" 0)
	(while (not e)
		(prompt "\n Vyber ktu : ")
		(if (setq e (entsel))
			(if (= (cdr (assoc 0 (entget (setq e (car e))))) "DIMENSION")
				(setq a (cdr (assoc 50 (entget e)))
					TYP (cdr (assoc 70 (entget e)))
					SMER (cdr (assoc 51 (entget e)))
					d10 (cdr (assoc 10 (entget e)))
					d13 (cdr (assoc 13 (entget e)))
					d14 (cdr (assoc 14 (entget e)))
				)
				(progn
					(prompt "\n Vybran objekt nen kta ! ")
					(setq e nil)
				)
			)
			(progn
				(prompt "\n Nic nevybrno ! ")
				(setq e nil)
			)
		)
	)
	(initget 1)
	(setq bod (trans (getpoint "\n Bod peruen : ") 1 0))
	
	(setq B (getvar "BLIPMODE"))
	(setvar "BLIPMODE" 0)
	(setq cl (getvar "clayer"))
	(command "_layer" "_s" (cdr (assoc 8 (entget e))) "")

    (defun KOT_ROTATE ()
	(command "_erase" e ""
		 "_ucs" ""
		 "_dim"	"_rotate" (/ (* a 180) pi) "_none" d13 "_none" bod "_none" d10 "" "_exit"
	)

	; Otoen smru textu kty dle pvodn

	(setq K (entget (entlast)))
	(setq ND (subst (cons 51 SMER)(assoc 51 K) K))
	(entmod ND)
	(entupd (entlast))

	; Konec otoen prvn kty
	; Pokraovn v kreslen druh kty

	(command "_dim"	"_rotate" (/ (* a 180) pi) "_none" bod "_none" d14 "_none" d10 "" "_exit"
		 "_ucs" "_p"
	)

	; Otoen smru textu kty dle pvodn

	(setq K (entget (entlast)))
	(setq ND (subst (cons 51 SMER)(assoc 51 K) K))
	(entmod ND)
	(entupd (entlast))

	; Konec otoen druh kty
    )	; Konec KOT_ROTATE

    (defun KOT_ALIGNED ()
	(if (equal (PDIM_ZAOK d14 8)(PDIM_ZAOK d10 8))
		(progn (prompt "\n Kta nem vynec ru - NELZE URIT HEL ! ")
			(terpri)
		)
		(progn
			(setq bodxx (polar bod (angle d14 d10) 100))
			(setq bod2 (inters d13 d14 bod bodxx NIL))
			(command "_erase" e ""
				 "_ucs" ""
				 "_dim"	"_aligned" d13 "_none" bod2 "_none" d10 "" "_exit"
			)

			; Otoen smru textu kty dle pvodn

			(setq K (entget (entlast)))
			(setq ND (subst (cons 51 SMER)(assoc 51 K) K))
			(entmod ND)
			(entupd (entlast))

			; Konec otoen prvn kty
			; Pokraovn v kreslen druh kty

			(command "_dim"	"_aligned" bod2 "_none" d14 "_none" d10 "" "_exit"
				 "_ucs" "_p"
			)

			; Otoen smru textu kty dle pvodn

			(setq K (entget (entlast)))
			(setq ND (subst (cons 51 SMER)(assoc 51 K) K))
			(entmod ND)
			(entupd (entlast))
			; Konec otoen druh kty
		)
	)
    )	; Konec KOT_ALIGNED

	(cond
		((equal TYP 32)
			(KOT_ROTATE)
		)   
		((equal TYP 160)
			(KOT_ROTATE)
		)   
		((equal TYP 33)
			(KOT_ALIGNED)
		)	
		((equal TYP 161)
			(KOT_ALIGNED)
		)	
		((equal TYP 35)
			(prompt "\n Vybran objekt je kta prmru - NEROZDLUJE SE ! ")
			(terpri)
		)	
		((equal TYP 163)
			(prompt "\n Vybran objekt je kta prmru - NEROZDLUJE SE ! ")
			(terpri)
		)	
		((equal TYP 36)
			(prompt "\n Vybran objekt je kta polomru - NEROZDLUJE SE ! ")
			(terpri)
		)	
		((equal TYP 164)
			(prompt "\n Vybran objekt je kta polomru - NEROZDLUJE SE ! ")
			(terpri)
		)	
		((equal TYP 37)
			(prompt "\n Vybran objekt je hlov kta - NEROZDLUJE SE ! ")
			(terpri)
		)	
		((equal TYP 165)
			(prompt "\n Vybran objekt je hlov kta - NEROZDLUJE SE ! ")
			(terpri)
		)	
		((equal TYP 38)
			(prompt "\n Vybran objekt je stanin kta - NEROZDLUJE SE ! ")
			(terpri)
		)	
		((equal TYP 166)
			(prompt "\n Vybran objekt je stanin kta - NEROZDLUJE SE ! ")
			(terpri)
		)	
		((> 1 0)	(prompt "\n Nebyla vybrna kta typu ROTATE nebo ALIGNED ! ")
				(terpri)
		)
	)   ; konec cond

	(command "_layer" "_s" cl "")
	(setvar "BLIPMODE" B)
	(setvar "CMDECHO" DECHO)
	(princ)
	(princ)
)

;----------------------------------------------------------------------------------------

;************************ FUNKCE KOTA_J  (SPOJ SOUSEDN KTY) **************************

;----------------------------------------------------------------------------------------

;************************* podfunkce KOTA_J 

(defun KO_ROT_COR ( p1 p2 u / d x y)
	(setq d (* (distance p1 p2) (cos (- (angle p1 p2) u)))
			x (* d (cos u))
			y (* d (sin u))
	)
	(list (+ (car p1) x)
			(+ (cadr p1) y)
			0
	)
)

;************************* podfunkce KOTA_J 


(defun PDIM_J_KOTA ( / cl B ED ND )
	(setq B (getvar "BLIPMODE"))
	(setvar "BLIPMODE" 0)
	(setq cl (getvar "clayer"))
	(command "_layer" "_s" (cdr (assoc 8 (entget e1))) "")
	(command "_erase" e1 e2 "") 
	(if (or (equal TYP1 32)(equal TYP1 160))
		(command "_ucs" ""
			 "_dim"	"_rotate" (/ (* a 180) pi) "_none" l "_none" p "_none" i "" "_exit"
			 "_ucs" "_p"
		)
		(command "_ucs" ""
			 "_dim"	"_aligned" l_ali "_none" p_ali "_none" i "" "_exit"
			 "_ucs" "_p"
		)
	)

; Otoen smru textu kty dle prvn vybran

	(setq ED (entget (entlast)))
	(setq ND (subst (cons 51 SMER)(assoc 51 ED) ED))
	(entmod ND)
	(entupd (entlast))

; Konec otoen
	
	(command "_layer" "_s" cl "")
	(setvar "BLIPMODE" B)
	(princ)
	(princ)
)

;**********************************

(defun C:KOTA_J ( / DECHO e d10 d11 d13 d14 p10 p11 p13 p14 l l_ali p p_ali i a TYP1 TYP2 SMER )
	(command "_undo" "_m")
	(setq DECHO (getvar "CMDECHO"))
	(setvar "CMDECHO" 0)
	(while (not e)
		(prompt "\n Vyber prvn ktu : ")
		(if (setq e (entsel))
			(if (= (cdr (assoc 0 (entget (setq e1 (car e))))) "DIMENSION")
				(setq a (cdr (assoc 50 (entget e1)))
					TYP1 (cdr (assoc 70 (entget e1)))
					SMER (cdr (assoc 51 (entget e1)))
					d10 (cdr (assoc 10 (entget e1)))
					d13 (cdr (assoc 13 (entget e1)))
					d14 (cdr (assoc 14 (entget e1)))
				)
				(progn
					(prompt "\n Vybran objekt nen kta ! ")
					(setq e nil)
				)
			)
			(progn
				(prompt "\n Nic nevybrno ! ")
				(setq e nil)
			)
		)
	)
	(setq e nil)
	(while (not e)
		(prompt "\n Vyber sousedn ktu k pipojen : ")
		(if (setq e (entsel))
			(if (= (cdr (assoc 0 (entget (setq e2 (car e))))) "DIMENSION")
				(if (equal e1 e2)
					(progn
						(setq e nil)
						(prompt "\n Nelze spojit tut ktu ! ")
					)
					(setq p10 (cdr (assoc 10 (entget e2)))
						TYP2 (cdr (assoc 70 (entget e2)))
						p13 (cdr (assoc 13 (entget e2)))
						p14 (cdr (assoc 14 (entget e2)))
					)
				)
				(progn
					(prompt "\n Vybran objekt nen kta ! ")
					(setq e nil)
				)
			)
			(progn
				(prompt "\n Nic nevybrno ! ")
				(setq e nil)
			)
		)
	)

	(cond
		((equal TYP1 32)
			(setq d11 (KO_ROT_COR d10 d13 a))
		)   
		((equal TYP1 160)
			(setq d11 (KO_ROT_COR d10 d13 a))
		)   
		((equal TYP1 33)
			(if (equal (PDIM_ZAOK d14 8)(PDIM_ZAOK d10 8))
				(setq d11 d10)
				(setq d11 (polar d13 (angle d14 d10) (distance d14 d10)))
			)
		)	
		((equal TYP1 161)
			(if (equal (PDIM_ZAOK d14 8)(PDIM_ZAOK d10 8))
				(setq d11 d10)
				(setq d11 (polar d13 (angle d14 d10) (distance d14 d10)))
			)
		)
		((> 1 0)	(prompt "\n Nebyla vybrna kta typu ROTATE nebo ALIGNED ! ")
				(terpri)
		)
	)   ; konec cond
	(cond	
		((equal TYP2 32)
			(setq p11 (KO_ROT_COR p10 p13 a))
		)   
		((equal TYP2 160)
			(setq p11 (KO_ROT_COR p10 p13 a))
		)   
		((equal TYP2 33)
			(if (equal (PDIM_ZAOK p14 8)(PDIM_ZAOK p10 8))
				(setq p11 p10)
				(setq p11 (polar p13 (angle p14 p10) (distance p14 p10)))
			)
		)	
		((equal TYP2 161)
			(if (equal (PDIM_ZAOK p14 8)(PDIM_ZAOK p10 8))
				(setq p11 p10)
				(setq p11 (polar p13 (angle p14 p10) (distance p14 p10)))
			)
		)	
		((> 1 0)	(prompt "\n Nebyla vybrna kta typu ROTATE nebo ALIGNED ! ")
				(terpri)
		)		
	)   ; konec cond


	(cond
		((equal (PDIM_ZAOK d10 8) (PDIM_ZAOK p10 8))
			(setq l d13
				p p13
				i d10
			)
			(setq p_ali (polar d13 (angle d13 d14) (distance d11 p11)))
			(progn
				(if (equal (PDIM_ZAOK p_ali 8) (PDIM_ZAOK l 8))
					(setq l_ali p13)
					(setq l_ali d13)
				)
			)
			(PDIM_J_KOTA)
		)
		((equal (PDIM_ZAOK d10 8) (PDIM_ZAOK p11 8))
			(setq l d13
				p p14
				i d10
			)
			(setq p_ali (polar d13 (angle d13 d14) (distance d11 p10)))
			(progn
				(if (equal (PDIM_ZAOK p_ali 8) (PDIM_ZAOK l 8))
					(setq l_ali p14)
					(setq l_ali d13)
				)
			)
			(PDIM_J_KOTA)
		)
		((equal (PDIM_ZAOK d11 8) (PDIM_ZAOK p10 8))
			(setq l p13
				p d14
				i d10
			)
			(setq p_ali (polar d14 (angle d14 d13) (distance d10 p11)))
			(progn
				(if (equal (PDIM_ZAOK p_ali 8) (PDIM_ZAOK l 8))
					(setq l_ali d14)
					(setq l_ali p13)
				)
			)
			(PDIM_J_KOTA)
		)
		((equal (PDIM_ZAOK d11 8) (PDIM_ZAOK p11 8))
			(setq l p14
				p d14
				i d10
			)
			(setq p_ali (polar d14 (angle d14 d13) (distance d10 p10)))
			(progn
				(if (equal (PDIM_ZAOK p_ali 8) (PDIM_ZAOK l 8))
					(setq l_ali d14)
					(setq l_ali p14)
				)
			)
			(PDIM_J_KOTA)
		)
		((> 1 0)	(prompt "\n Byla vybrna nenavazujc kta ! "))
	)
	(setvar "CMDECHO" DECHO)
	(princ)
)
		

;----------------------------------------------------------------------------------------

;***************** FUNKCE KOTA_VC  (UPRAV DLKY VYNECCH AR KT) *********************

;----------------------------------------------------------------------------------------


;************************* podfunkce KOTA_VC

(defun setsys ()
  (sysvar 		; podfunkce viz dle	
    '( ("TEXTEVAL" 1)
       ("CMDECHO" 0)
       ("DIMASO" 1)
       ("DIMZIN" 8)
     )
  )     
)

;*************************

(defun C:KOTA_VC (/ oerr osys i ssl flag) 
  (setq oerr *error*
        *error* *dim_err*
        osys (setsys)
        i 0
  )      
  (setq *EXTLEN* (get_extl))
  (if (setq ssl (sslist (ssget '((0 . "DIMENSION")))))
    (progn
      (command "_.UNDO" "_Group")
      (foreach en ssl
        (setq flag (dxf 70 (entget en)))
        (if (not (apply 'or (mapcar '(lambda (x) (= x (logand x flag))) 
                                    '(2 3 4 5 6 70))))
          (progn
            (setq i (1+ i))
            (if *EXTLEN* (dtrim en *EXTLEN*))
            (if *DIMSUP* (dimsup en))
          )
        )
      )
      (command "_.UNDO" "_End")
      (princ (strcat "\n" (itoa i) " dimension(s) changed. "))
    )  
  )
  (sysvar osys)
  (setq *error* oerr)
  (princ)
)


;************************* podfunkce KOTA_VC

;;;  Function: SYSVAR
;;;
;;;  Set and restore system variables.
;;;
(defun sysvar (l)
  (mapcar 
    '(lambda (x / var val vlist)
       (setq var (if (listp x) (car x) x)
             val (if (listp x) (eval (cadr x)) nil)
           vlist (list var (getvar var))
       )
       (if val (setvar var val))
       vlist
     )
     l      
  )
)


;;; Get extension lines length:
(defun get_extl (/ l)
  (setq l
    (getdist (strcat "\nExtension lines length <" 
                     (if *EXTLEN* (rtos *EXTLEN* 2 2) "") ">: ")))
  (if l
    (setq *EXTLEN* l)
    (if *EXTLEN* (setq l *EXTLEN*))
  )
)

(defun to2d (pt)
  (list (car pt) (cadr pt))
)


;;;  convert selection set to list,
;;;  Note: it's also wise to use ai_ssget, because some ents could be
;;;        on locked layers
;;;  Ex: (sslist (ai_ssget (ssget))) => list of selected unlocked ents
;;;  or  (mapcar 'entupd (sslist (ssget "X" '((8 . "TEMP")))))
;;;       - regens all entities on layer TEMP
(defun SSLIST (ss / n lst)
  (if (= (type ss) 'PICKSET)
    (repeat (setq n (sslength ss))
      (setq n (1- n)
            lst (cons (ssname ss n) lst)))))


;;;  Get DXF group code value:
(defun dxf (grp ele) (cdr (assoc grp ele)))



;;; Trim dimension extension lines:
;;; rev. 05.08.1997  CC
;;;      06.08.1997  CC
;;;
(defun dtrim (en l / ent ang p1 p2 p3 p4 ang2)
  (setq ent (entget en)
         p1 (to2d (cdr (assoc 10 ent)))
         p2 (to2d (cdr (assoc 14 ent)))
         p3 (to2d (cdr (assoc 13 ent)))
        ang (if (= 1 (logand 1 (cdr (assoc 70 ent))))
              (angle p3 p2)                 ; if aligned, calculate angle
              (cdr (assoc 50 ent))
            )
         p4 (inters p1 (polar p1 ang 1) 
                    p3 (polar p3 (+ ang (/ pi 2)) 1) 
                    nil
            )
  )
  ;; the direction of the new extension lines depends on the first
  ;; extension line or, if there is no first extension line, on the
  ;; second. If there are no extension lines at all, the direction will 
  ;; be calculated to (- ang (/ pi 2)) ... ang = angle of dimension line.       
  (if (not (equal p3 p4 0.0001))
    (setq p3 (polar p4 (angle p4 p3) l))
  )
  (if (not (equal p1 p2 0.0001))
    (setq p2 (polar p1 (angle p1 p2) l))
  )  
  (setq ent (subst (cons 14 p2) (assoc 14 ent) ent)
        ent (subst (cons 13 p3) (assoc 13 ent) ent)
  )
  (entmod ent)
)


;************************************************************************

;  	program pro vypsn textu velikosti oznaen plochy v m2
;		- velikost se d velikost kt

;************************************************************************

(defun C:PLO (/)     ;  pro kresbu v milimetrech

(command "_TEXT" (getpoint "\nVkladaci bod:")
                 (menucmd "M=$(*,$(getvar,dimtxt),$(getvar,dimscale))")
                 0
                 (menucmd "M=$(rtos,$(*,$(getvar,area),0.000001),2,2) m\U+00B2")
)
(princ)
)

(defun C:PLOm (/)     ;  pro kresbu v metrech

(command "_TEXT" (getpoint "\nVkladaci bod:")
                 (menucmd "M=$(*,$(getvar,dimtxt),$(getvar,dimscale))")
                 0
                 (menucmd "M=$(rtos,$(getvar,area),2,2) m\U+00B2")
)
(princ)
)
