;Nstroje pro interpolaci. Vyaduje blok se dvma atributy kter se jmenuje "wont_h_BLOK"

;-------------------------------------------------------------------------------------------
;made by Alfred :-D
;Toto je FREEWARE a je mono ho it jak kdo uzn za vhodn (vcelku i po stech).
;Prost si s tm dlejte co chcete...
;
;Autor neru za zpsoben problmy a chyby v programech (nevim o nich, ale mozna tam jsou).
;Pokud na njak chyby narazte, kontaktujte m prosm na adrese 'alfred.samca@seznam.cz'
;Jestli mte zjem a zajm Vs LISP mrknte na moje strnky
;http://mujweb.cz/Pocitace/alfred
;nebo
;http://mine.at/alfred
;Strnky jsou prastar a ji neudrovan, ale mon mohou trochu zatenkm pomoct.
;-------------------------------------------------------------------------------------------
;

;Pkazy:
;	UU....vlo blok, piem z-tov souadnice se zadv (souasn je hodnotou atributu
;	YY....vlo blok, piem hodnota atributu je Z-tov souadnice vkldacho bodu
;	TT....vlo blok do bodu s poadovanou vkou. Hodnota atributu obsahuje pslunou interpolovanou vku.
;		    Vhodn pi tvorb vrstevnic. (vstup - 3 body, 1 vka)
;                                                                 
;	EE....interpolace, kde vsledek je hodnota atributu v bloku. Je nutno zadvat vky vstupnch bod
;		    (vstup - 3 body, 2 vky)
;	WW....interpolace, kde vsledek je hodnota atributu v bloku. NELZE zadvat vky bod ale bere si Z-tovou souadnici
;		    vstupnch bod (vstup - 3 body)

;verze 1.1 - fce ww vklada blok do prislusne vysky
;verze 1.11 - fce ww vypisuje vysky vstupnich bodu - kontrola
;verze 1.111 - prejmenovana fce "help_in_z" na in_z--help
;verze 1.2 - vlastn error funkce; pepnn ATTDIA na 0 a zpt (dialog u vloen atributu)
;verze 1.21 - fce EE vklada blok do prislusne vysky
;verze 1.22 - poet des. mist dle promenne "LUPREC"
;verze 1.23 - pidan atribut "popis" - nap. na pvod dat
;verze 1.24 - oprava nkolika chybek
;


(defun c:in_z--help ()
	(print "WW....interpolace, kde vsledek je hodnota atributu v bloku. NELZE zadvat vky bod ale bere si Z-tovou souadnici vstupnch bod (vstup - 3 body)")
	(print "EE....interpolace, kde vsledek je hodnota atributu v bloku. Je nutno zadvat vky vstupnch bod (vstup - 3 body, 2 vky)")
	(print "YY....vlo blok, piem hodnota atributu je Z-tov souadnice vkldacho bodu")
	(print "TT....vlo blok do bodu s poadovanou vkou. Hodnota atributu obsahuje pslunou interpolovanou vku. Vhodn pi tvorb vrstevnic. (vstup - 3 body, 1 vka)")
	(print "UU....vlo blok, piem z-tov souadnice se zadv (souasn je hodnotou atributu ")
	(print "in_z--help ..... vypise napovedu")
	(print)
)


(defun *error_in_z* (msg)
  (setq *error* *old_error*)
  (princ "error :")
  (setvar "attdia" old_attdia)
  (princ msg)
  (setvar "osmode" chyt)
  (if (/= LineToDel nil)
	(progn
	  (entdel  LineToDel)
	  (setq LineToDel nil)
	)
  )
  (print)
);defun

(defun sqr(x) (* x x))

;_________________________________________________________________________________________________
(defun c:uu ( / h point chyt)
  (setq *old_error* *error*)
  (setq *error* *error_in_z*)
  (setq chyt (getvar "osmode"))
  (setq old_attdia (getvar "attdia"))
  (setvar "attdia" 0)
  (setvar "cmdecho" 0)
  (setq point 0)
  (while (/= point nil)
	(setq point (getpoint "Bod vloen: "))
	(if (/= point nil)
	  (progn
		(print)
		(setq h (getreal "Vka: "))
		(setq point (list (car point) (cadr point) h))
		(setq chyt (getvar "osmode"))
		(setvar "osmode" 0)
		(command "_insert" "wont_h_BLOK" point "" "" "0" (rtos (caddr point) 2 (getvar "luprec")) "run zadn (uu)")
		(setvar "osmode" chyt)
	  )
	)
  )
  (setvar "cmdecho" 1)
  (setvar "attdia" old_attdia)
  (setq *error* *old_error*)
  (print)
)


;_________________________________________________________________________________________________
(defun c:yy ( / point chyt)
  (setq *old_error* *error*)
  (setq *error* *error_in_z*)
  (setq chyt (getvar "osmode"))
  (setq old_attdia (getvar "attdia"))
  (setvar "attdia" 0)
  (setvar "cmdecho" 0)
  (setq point 0)
  (while (/= point nil)
		(setq point (getpoint "Bod vloen"))
		(print)
		(if (/= point nil)
			(progn
				(setq chyt (getvar "osmode"))
				(setvar "osmode" 0)
				(command "_insert" "wont_h_BLOK" point "" "" "0" (rtos (caddr point) 2 (getvar "luprec")) "automatick dle chycen (yy)")
				(setvar "osmode" chyt)
			)
		);if
  );while
  (setvar "cmdecho" 1)
  (setq *error* *old_error*)
	(print "Konec...")
  (print)
)

;_________________________________________________________________________________________________
(defun c:TT ( / b1 b2 n1 n2 p1 d2d) 
  (setq *old_error* *error*)
  (setq *error* *error_in_z*)
  (setq chyt (getvar "osmode"))
  (setq old_attdia (getvar "attdia"))
  (setvar "attdia" 0)
  (setvar "cmdecho" 0)

  (while (= b1 nil) (setq b1 (getpoint "\Prvn bod : ")))
  (princ (caddr b1))(princ " ")
  (while (= b2 nil) (setq b2 (getpoint "\Druh bod : ")))
  (princ (caddr b2))(princ " ")
  (print)

  (setq n1 (caddr b1))
  (setq n2 (caddr b2))

  ;**********************************************
;  (setq n1 (getreal "Zadej prvn vku: "))
;  (print)
;  (setq n2 (getreal "Zadej druhou vku: "))
  ;**********************************************

  (if (= wont_h nil) (setq wont_h 0.0))
  (setq wont_h_old wont_h)

  (setq wont_h (getreal (strcat "Poadovan vka <" (rtos WONT_H 2 3) ">: ")))
  (if (= wont_h nil) (setq wont_h wont_h_old))

    (setq b1x (cadr b1))
    (setq b1y (car b1))
    (setq b2x (cadr b2))
    (setq b2y (car b2))

    (setq d2d_1 (sqrt (+ (sqr (- b2x b1x))
				(sqr (- b2y b1y)
			   )
			)
		)
   )
   (setq dist2D_2 (* (/ (- wont_h n1) (- n2 n1)) d2d_1))
   (setq ang (angle b1 b2))
   
   (setq new_x (+ b1y (* dist2D_2 (cos ang))))
   (setq new_y (+ b1x (* dist2D_2 (sin ang))))
   (setq p_new (LIST new_x new_y wont_h))

  (setq chyt (getvar "osmode"))
  (setvar "osmode" 0)
  (command "_insert" "wont_h_BLOK" p_new "" "" "0" (rtos wont_h 2 (getvar "luprec")) "dopotan-inter(extra)polace (tt)")
  (setvar "osmode" chyt)
  
  (print "Konec...")
  (setvar "cmdecho" 1)
  (setvar "attdia" old_attdia)
  (setq *error* *old_error*)
  (print)
)


;_________________________________________________________________________________________________
(defun c:ee( / n1 n2 n3 p1 p2 p3 b1x b2x b3x b1y b2y b3y chyt LineToDel)
    (setq *old_error* *error*)
    (setq *error* *error_in_z*)
    (setq chyt (getvar "osmode"))
    (setq old_attdia (getvar "attdia"))
    (setvar "attdia" 0)
    (setq vypisy (getvar "cmdecho"))
    (setvar "cmdecho" 0)
    (setq b1 (getpoint "\Prvn bod : "))
    (setq b2 (getpoint b1 "\Druh bod : "))
     (setq OldColor (getvar "cecolor"))
     (setq OldLineType (getvar "celtype"))
     (setvar "cecolor" "7")
     (setvar "celtype" "continuous")
    (setq chyt (getvar "osmode"))
    (setvar "osmode" 0)
    (command "_line" b1 b2)(command)
    (setvar "osmode" chyt)
    (setvar "cecolor" OldColor)
    (setvar "celtype" OldLineType)
    (setq LineToDel (entlast))
    (setq b3 (getpoint b2 "\Tet bod : "))
    (setq b1x (cadr b1))
    (setq b1y (car b1))
    (setq b2x (cadr b2))
    (setq b2y (car b2))
    (setq b3x (cadr b3))
    (setq b3y (car b3))
    (print)
    (setq n1 (getreal "Zadej prvn vku: "))
    (print)
    (setq n2 (getreal "Zadej druhou vku: "))
    (entdel  LineToDel)
    (setq d2d_1 (sqrt (+ (sqr (- b2x b1x))
				(sqr (- b2y b1y)
			   )
			)
		)
    )
    (setq d2d_2 (sqrt (+ (sqr (- b3x b1x))
				(sqr (- b3y b1y)
			   )
			)
		)
   )
   (setq n3 (+ (* (/ (- n2 n1) d2d_1) d2d_2) n1))
  (setq chyt (getvar "osmode"))
  (setvar "osmode" 0)
  (setq b3 (list (car b3) (cadr b3) n3))
  (command "_insert" "wont_h_BLOK" b3 "" "" "0" (rtos n3 2 (getvar "luprec")) "dopotan-interpolace (ee)")
  (setvar "osmode" chyt)

(setvar "cmdecho" vypisy)
(setvar "attdia" old_attdia)
(setq *error* *old_error*)
(print)
)

;_________________________________________________________________________________________________
(defun c:ww ( / n1 n2 n3 p1 p2 p3 b1x b2x b3x b1y b2y b3y chyt LineToDel)
    (setq *old_error* *error*)
    (setq *error* *error_in_z*)
    (setq old_attdia (getvar "attdia"))
    (setvar "attdia" 0)
    (setq vypisy (getvar "cmdecho"))
    (setvar "cmdecho" 0)
    (setq b1 (getpoint "\Prvn bod : "))
	  (if (/= b1 nil)
			(progn
    	  (princ (caddr b1))(princ " ")
    		(setq b2 (getpoint b1 "\Druh bod : "))
	  		(if (/= b2 nil)
					(progn
				    (princ (caddr b2))(princ " ")
				    (setq OldColor (getvar "cecolor"))
				    (setq OldLineType (getvar "celtype"))
				    (setvar "cecolor" "7")
				    (setvar "celtype" "continuous")
				    (setq chyt (getvar "osmode"))
				    (setvar "osmode" 0)
				    (command "_line" b1 b2)(command)
				    (setvar "osmode" chyt)    
				    (setvar "cecolor" OldColor)
				    (setvar "celtype" OldLineType)
				    (setq LineToDel (entlast))
				    (setq b3 (getpoint b2 "\Tet bod : "))
						(if (/= b3 nil)
							(progn
								    
								    (setq b1x (cadr b1))
								    (setq b1y (car b1))
								    (setq b2x (cadr b2))
								    (setq b2y (car b2))
								    (setq b3x (cadr b3))
								    (setq b3y (car b3))
								    (print)
								    
								    (setq n1 (caddr b1))  
								    (setq n2 (caddr b2))  

								    
								    (setq d2d_1 (sqrt (+ (sqr (- b2x b1x))
												(sqr (- b2y b1y)
											   )
											)
										)
								    )
								    (setq d2d_2 (sqrt (+ (sqr (- b3x b1x))
												(sqr (- b3y b1y)
											   )
											)
										)
								   )
								   (setq n3 (+ (* (/ (- n2 n1) d2d_1) d2d_2) n1))

								  (setq chyt (getvar "osmode"))
								  (setvar "osmode" 0)
								  (setq b3 (list (car b3) (cadr b3) n3))
								  (command "_insert" "wont_h_BLOK" b3 "" "" "0" (rtos n3 2 (getvar "luprec")) "dopotan-interpolace (ww)")
								  (setvar "osmode" chyt)
						
				      );progn - treti bod
						);if - treti bod
		      );progn - druhy bod
				);if - druhy bod
				
      );progn - prvn bod
		);if - prvn bod
	(if (/= LineToDel nil)(entdel  LineToDel))
	(setvar "cmdecho" vypisy)
	(setvar "attdia" old_attdia)
	(setq *error* *old_error*)
	(print "Konec...")
	(print)
)


;*****************************************************
;VPIS NPOVDY PI NATEN
(c:in_z--help)
