;;; program MTEXTCF.LSP   (c) 12.4.1999 Jan Bastecky
;;;=================================================================
;;; MTextCleanFormat - odstrani formatovani z MTEXTU
;;; modifikace na koty plus upravy, 24.1.2001 CAD Studio
;;;

(defun MTEXTCF0	(txr / pozice delka znak ntx)		; vlastni vykonna funkce, prevadi TXR na NTX
;(PRINC TXR)
  (setq ntx "")
  (setq pozice 1)
  (setq delka (strlen txr))
  (while (<= pozice delka)
    (setq znak (substr txr pozice 1))
    (if	(= znak "\\")					;pokud je lomitko      
      (progn
 (setq pozice (1+ pozice))			; posunu se na dalsi znak
 (setq znak (substr txr pozice 1))
 (if (or (= znak "{") (= znak "}") (= znak "\\") (= znak "P")); bylo druhe lomitko nebo sloz.zavorka? (nebo P - oprava: VM 31.7.2001)
   (setq ntx (strcat ntx "\\" znak))		; ANO -> vysledny znak kopiruji
   (progn					; NE -> ignoruji znaky az do ";"
     (while (and (/= znak ";") (<= pozice delka))
       (setq pozice (1+ pozice))
       (setq znak (substr txr pozice 1))
       )
     )
   )
 )
      (if (and (/= znak "{") (/= znak "}"))		; pokud neni lomitko ... a neni to ani zavorka
 (setq ntx (strcat ntx znak))			; tak pouze kopiruji vstup
 )
      )
    (setq pozice (1+ pozice))
    )
  (setq ntx ntx)
  )


;;;===================================================================
;;; MTextCleanFormat - odstrani formatovani z MTEXTU
;;;
(defun c:MTEXTCF (/ ss1 cnt en txr ntx)
  (setq ss1 (ssget '((-4 . "<OR")(0 . "MTEXT")(0 . "DIMENSION")(-4 . "OR>"))))			; vybereme MTEXTy a DIMy
  (if (null ss1)					; vybralo se neco?
    (progn
      (princ "Nevybral jste dn MTEXT (No MTEXT in selection)")
      (quit)
      )
    )

  (setq cnt 0)
  (repeat (sslength ss1)				; cyklus pres vyberovou mno inu
    (setq en (entget (ssname ss1 cnt)))			; nactu entitu
    (setq txr (cdr (assoc 1 en)))			; vypreparuju text
    (setq ntx (mtextcf0 txr))				; provedu vlastni konverzi
    (if	(/= txr ntx)					; pokud se text zmenil
      (entmod (subst (cons 1 ntx) (assoc 1 en) en))	; -> tak ho vymenim ve vykresove databazi
      )
    (setq cnt (1+ cnt))					; posunu se na dalsi entitu
    )
  (princ)
  )

;;; end of file
