	;                                                   ver 1.0               ;
	; CREATED       ||   || || || //  |||                                     ;
	;        |||||  ||   || || ||||  || ||  |||||                             ;
	;   by          ||||  |||  || \\  |||                                     ;
	;                                                                         ;
	;                                                   copyright -LuK.O.-    ;

 ;											;
 ;			           ***** ERROR *****					;
 ;											;

(defun initerr ()					;init error
  (setq oldosnapcoord (getvar "osnapcoord"))
  (setq oldosmode (getvar "osmode"))
  (setq olddimzin (getvar "dimzin"))	 
  (setq oldlayer (getvar "clayer"))			;save settings
  (setq oldpick (getvar "pickbox"))
  (setq oldblipmode (getvar "blipmode"))
  (setq oldmenuecho (getvar "menuecho"))
  (setq oldhighlight (getvar "highlight"))
  (setq temperr *error*)				;save *error*
  (setq *error* trap)					;reassign *error*
  (princ)
);defun
;;;*===========================================================
(defun trap (errmsg)					;define trap
  (command nil nil nil)
  (if (not (member errmsg '("console break" "Function Cancelled"))
      )
    (princ (strcat "\n*Error*  " errmsg "  :-("))			;print message
  )
  (setvar "osnapcoord" oldosnapcoord)
  (setvar "osmode" oldosmode)
  (setvar "dimzin" olddimzin)
  (setvar "clayer" oldlayer)				;reset settings
  (setvar "blipmode" oldblipmode)
  (setvar "menuecho" oldmenuecho)
  (setvar "highlight" oldhighlight)
  (setvar "pickbox" oldpick)
  ;(terpri)
  (setq *error* temperr)				;restore *error*
);defun
;;;*===========================================================
(defun reset ()						;define reset
  (setq *error* temperr)				;restore *error*
  (setvar "osnapcoord" oldosnapcoord)
  (setvar "osmode" oldosmode)
  (setvar "dimzin" olddimzin)
  (setvar "clayer" oldlayer)				;reset settings
  (setvar "blipmode" oldblipmode)
  (setvar "menuecho" oldmenuecho)
  (setvar "highlight" oldhighlight)
  (setvar "pickbox" oldpick)
  (princ)
);defun


 ;		vyskovy zakruzovaci oblouk						;
 ;			           ***** PARABOLA *****					;
 ;											;


; vpoet sklonu
(defun sklon(dX dY)
  (* (/ dY dX) 100.0)
) ;defun

; radiny na stupn
(defun s->stup(h d)
  (/ (* 180.0 (atan (* h 10.0) d)) pi) 	;prevys 
) ;defun

; nahrazen desetinn teky rkou
(defun nahrad (retez stary novy / shoda i test)
  (setq shoda "N")
  (setq i 1)
  (while (eq shoda "N")
    (setq test (substr retez i (strlen stary)))
    (if (eq test stary)
        (setq shoda "A")
        (progn
	  (cond ((<= i (- (strlen retez) (strlen stary)))
		 (setq i (+ i 1))
		 )
		((> i (- (strlen retez) (strlen stary)))
		 (setq shoda "O")
		 )
		)
	  ) ;progn 
      ) ;if
    ) ;while
  (cond ((eq shoda "A")
  (strcat
    (substr retez 1 (- i 1)) NOVY
    (substr retez (+ i (strlen stary))))
  )
	((eq shoda "O")
	 (prompt "\nPvodn ezetec nebyl nalezen!")
	 (setq i nil)
	 )
	) ; cond
  ) ;defun


; hlavn funkce 
(defun c:vyspar(/ tecna1 typt1 typt11 tecna2 typt2 typt22 polomer1 stPt1 endPt1 stPt2 endPt2 Xs1 Ys1 Xe1 Ye1 dX1 dY1 Xs2 Ys2 Xe2 Ye2 dX2 dY2 Xp Yp s1 s2 te yte1 yte2 ymax t0 x0 xStart yStart vzd xn x yn1 yn y bod bodm z n mer1 txtPt txtHeight1 txtHeight2 bodtextu1 bodtextu2 bodtextu3 bodtextu4 bodtextu5)
  (initerr)
  ; nastaven sys. promnnch 
  (setvar "dimzin" 0)
  (setvar "osnapcoord" 1)
  ; Zadn 1. teny 
  (setq tecna1 (entsel "\nVyberte levou tenu :"))
  (while (not tecna1)
         (princ "\nNebyla vybrna dn entita")
    	 (setq tecna1 (entsel "\nVyberte levou tenu :"))
  ) ;while
  (if tecna1
      (progn
  	(setq typt1 (cdr (assoc 0 (entget (car tecna1)))))
	(while (/= typt1 "LINE")
	    	(princ "..Nebyla zadna entita typu RA/LINE")
	  	(setq tecna1 (entsel "\nVyberte levou tenu :"))
	  		(while (not tecna1)
         		(princ "\nNebyla vybrna dn entita")
    	 		(setq tecna1 (entsel "\nVyberte levou tenu :"))
  			) ;while
		(setq typt1 (cdr (assoc 0 (entget (car tecna1)))))
	) ;while
      ) ;progn
	  
  ) ;if
  (setq typt11 (cdr (assoc -1 (entget (car tecna1)))))		; jmno entity 

  ; Zadn 2. teny 
  (setq tecna2 (entsel "\nVyberte pravou tenu :"))
  (while (not tecna2)
         (princ "\nNebyla vybrna dn entita")
    	 (setq tecna2 (entsel "\nVyberte pravou tenu :"))
  ) ;while
  (if tecna2
      (progn
	(setq typt22 (cdr (assoc -1 (entget (car tecna2)))))
	(while (eq typt11 typt22)
               (princ "..Zadan entita je shodn s pedchoz")
               (setq tecna2 (entsel "\nVyberte pravou tenu :"))
	  		(while (not tecna2)
         		       (princ "\nNebyla vybrna dn entita")
    	 		       (setq tecna2 (entsel "\nVyberte pravou tenu :"))
  			) ;while
	       (setq typt22 (cdr (assoc -1 (entget (car tecna2)))))
  	) ;while
	(setq typt2 (cdr (assoc 0 (entget (car tecna2)))))
	(while (/= typt2 "LINE")
	    	(princ "..Nebyla zadna entita typu RA/LINE")
	  	(setq tecna2 (entsel "\nVyberte pravou tenu :"))
	  		(while (not tecna2)
         		       (princ "\nNebyla vybrna dn entita")
    	 		       (setq tecna2 (entsel "\nVyberte pravou tenu :"))
  			) ;while
		(setq typt2 (cdr (assoc 0 (entget (car tecna2)))))
	) ;while
      	(princ "\nNo proto! :-)")
      ) ;progn
  ) ;if
      
  ; poten a koncov body 
  (setq stPt1 (cdr (assoc 10 (entget (car tecna1)))))
  (setq endPt1 (cdr (assoc 11 (entget (car tecna1)))))
  (setq stPt2 (cdr (assoc 10 (entget (car tecna2)))))
  (setq endPt2 (cdr (assoc 11 (entget (car tecna2)))))
  ; prsek 
  (setq prus (inters stPt1 endPt1 stPt2 endPt2 nil))
  (setq Xp (car prus) Yp (cadr prus))				; souadnice prseku 
  ; delta X1,Y1 
  (setq Xs1 (car stPt1) Ys1 (cadr stPt1))
  (setq Xe1 (car endPt1) Ye1 (cadr endPt1))
  (setq dX1 (- Xe1 Xs1) dY1 (/ (- Ye1 Ys1) 10))	;prevys 

  ; delta X2,Y2 
  (setq Xs2 (car stPt2) Ys2 (cadr stPt2))
  (setq Xe2 (car endPt2) Ye2 (cadr endPt2))
  (setq dX2 (- Xe2 Xs2) dY2 (/ (- Ye2 Ys2) 10))	;prevys 
  
  ; skon prvn teny 
  (setq s1 (sklon dX1 dY1))
    ;(princ (strcat "\nsklon teny jedna je: " (rtos s1 2 2) "%"))
  ; skon prvn teny 
  (setq s2 (sklon dX2 dY2))
    ;(princ (strcat "\nsklon teny dva je: " (rtos s2 2 2) "%"))
  (if (= s1 s2)
      	 (progn
         (command "_textscr")
      	 (princ "\nTeny maj stejn sklon...nelze vytvoit parabolu")
	 (princ "\nTeny maj stejn sklon...nelze vytvoit parabolu")
	 (princ "\n")
      	 (exit)
	 ) ;progn
  ) ;if

  ; Zadn polomru 
  (initget (+ 2 4))
  (setq polomer1 (if (null polomer) 1.0 polomer))
  (setq polomer (getreal (strcat "\nZadejte polomr oskulan krunice paraboly<" (rtos polomer1 2 2) "> :")))
  (if (null polomer) (setq polomer polomer1))

  ; vpoet dlky teny 
  (setq te (/ (* (abs (- s1 s2)) polomer) 200.0))
    ;(princ (strcat "\ndlka teny je " (rtos te)))
  ; ypsilonov souadnice 1. teny 
  (setq yte1 (/ (* s1 te) 100.0))
    (princ (strcat "\ny-ov sou. lev teny je " (rtos yte1)))
  ; ypsilonov souadnice 2. teny 
  (setq yte2 (/ (* s2 te) 100.0))
    (princ (strcat "\ny-ov sou. prav teny je " (rtos yte2)))
  ; ymax 
  (setq ymax (/ (expt te 2) (* 2.0 polomer)))
    ;(princ (strcat "\nymax je " (rtos ymax)))
  ; t0 
  (setq t0 (/ (* s1 polomer) 200.0))
    ;(princ (strcat "\nT0 je " (rtos t0)))
  ; x0
  (setq x0 (* 2.0 t0))
    ;(princ (strcat "\nx0 je " (rtos x0)))
  ; bod potku paraboly
  (setq xStart (- Xp te))
  (setq yStart (- Yp (* yte1 10)))		;prevys 

  ; body pro parabolu 
  (setq vzd (/ te 100.0))
  (setq xn (* vzd -1.0))
  (setq z 1)
  (while (< xn (* 2.0 te))
    	 (setq n -1)
    	 (setq n (1+ n))
    	 (setq xn (+ xn vzd))
    	 (if (<= n 100)
	     (progn
	       (setq x xn)
	       (setq yn1 (* (abs s1) x 0.01))
	     ) ;progn
	     (progn
	       (setq x (- (* 2.0 te) xn))
	       (setq yn1 (* (abs s2) (- (* 2.0 te) x) 0.01))
	     ) ;progn
	 ) ;if
    	 (setq yn (/ (expt x 2) (* 2.0 polomer)))
    	 (setq y (- yn1 yn))
    	 (cond ((>= s1 0.0)			; vtven pro rzn sklony teen
		(if (< s1 s2)
		    (setq bod (list (+ x xStart) (+ (* (+ y (* 2.0 yn)) 10) yStart)))
		    (setq bod (list (+ x xStart) (+ (* y 10) yStart)))
		) ;if
	       )	
	       ((< s1 0.0)
		(if (> s1 s2)
		    (setq bod (list (+ x xStart) (+ (* (+ y (* 2.0 yn)) -10) yStart)))
		    (setq bod (list (+ x xStart) (+ (* y -10) yStart)))
		) ;if
	       )
	       ((and (= s1 0.0) (> s2 0.0))
		(setq bod (list (+ x xStart) (+ (* y -10) yStart)))
	       )
	 ) ;cond 
    	 (if (= z 1)
      	   (progn (command "_PLINE" bod))
           (progn (command bod))
    	 ) ;if
    	 (setq bodm bod)
	 (setq z (1+ z))
  ) ;while
  (command "")

  ; Zadn mtka 
  (initget (+ 2 4))
  (setq mer1 (if (null mer) 1000.0 mer))
  (setq mer (getreal (strcat "\nZadejte mtko vkresu<1:" (rtos mer1 2 2) "> :")))
  (if (null mer) (setq mer mer1))
  ; vka textu
  (setq txtHeight1 (* 0.004 mer))
  (setq txtHeight2 (* 0.003 mer))

  ; Uren bodu vloen
  (initget (+ 2 4)) 
  (setq txtPt (getpoint "\nZadejte bod vloen textu <Automaticky> :"))
  (if (null txtPt)
      (progn
	; body vloen textu automaticky 
  	(setq bodtextu1 (list Xp (+ Yp (* 5 txtHeight1))))
  	(setq bodtextu2 (list Xp (+ Yp (* 4 txtHeight1))))
  	(setq bodtextu3 (list Xp (+ Yp (* 3 txtHeight1))))
  	(setq bodtextu4 (list (- Xp (* 0.5 txtHeight1)) (+ Yp (* 1.5 txtHeight1))))
  	(setq bodtextu5 (list (+ Xp (* 0.5 txtHeight1)) (+ Yp (* 1.5 txtHeight1)))) 
      ) ;progn
     (progn
        ; body vloen textu zadan
        (setq bodtextu1 txtPt)
        (setq bodtextu2 (list (car txtPt) (- (cadr txtPt) (* 2 txtHeight1))))
  	(setq bodtextu3 (list (car txtPt) (- (cadr txtPt) (* 3 txtHeight1))))
  	(setq bodtextu4 (list (- (car txtPt) (* 0.5 txtHeight1)) (- (cadr txtPt) (* 4 txtHeight1))))
  	(setq bodtextu5 (list (+ (car txtPt) (* 0.5 txtHeight1)) (- (cadr txtPt) (* 4 txtHeight1))))
     ) ;progn
  ) ;if
	 
  ; vloen textu 
  (command "_text" "_justify" "_center" bodtextu1 txtHeight1 "0" (strcat "R=" (nahrad (rtos polomer 2 1) "." ",") "m"))					; polomr 
  (command "_text" "_justify" "_center" bodtextu2 txtHeight2 "0" (strcat "T=" (nahrad (rtos te 2 2) "." ",") "m"))					; tena 
  (command "_text" "_justify" "_center" bodtextu3 txtHeight2 "0" (strcat "ymax=" (nahrad (rtos ymax 2 2) "." ",") "m   x0=" (nahrad (rtos x0 2 2) "." ",") "m"))		; ymax a x0
  (command "_units" "" "" "1" "4" "" "")
  (command "_text" "_justify" "_right" bodtextu4 txtHeight2 (s->stup dY1 dX1) (strcat "s1=" (nahrad (rtos s1 2 2) "." ",") "%"))				; s1 
  (command "_text" bodtextu5 txtHeight2 (s->stup dY2 dX2) (strcat "s2=" (nahrad (rtos s2 2 2) "." ",") "%"))						; s2
  
  ; vpis vypotanch hodnot
  (command "_textscr")
  (princ "\n")
  (princ "\n")
  (princ "\n")
  (princ "\n")
  (princ "\n***** VYPOTAN PARAMETRY PARABOLY *****")
  (princ (strcat "\nsklon lev teny = " (rtos s1 2 2) "%"))
  (princ (strcat "\nsklon prav teny = " (rtos s2 2 2) "%"))
  (princ (strcat "\ndlka teny T = " (rtos te)))
  (princ (strcat "\nymax = " (rtos ymax)))
  (princ (strcat "\nT0 = " (rtos (abs t0))))
  (princ (strcat "\nx0 = " (rtos (abs x0))))
  (princ "\nZmknte Enter nebo mezernk / Press Enter or Space ... ")
  (command pause)
  (command "_graphscr")
  (princ "\n")
  (reset) 	; vrcen nastaven uivatele 

) ;defun

(defun S::STARTUP()
  (princ "\n 2004 -LUKO-   voln iiteln se svolenm sleny pan inenrky Hanky Kantorov")
  (princ "\nVyrobeno pro slenu pan inenrku Hanku Kantorovou :-)")
) ;defun

menucmd 