/* -------------------------------------------------------------
   DWGSCALE.dcl  Called by DWGSCALE.LSP
   (c) Copyright 2001 TimeSavers for CAD
   ------------------------------------------------------------- */
dcl_settings : default_dcl_settings { audit_level = 3; }

sclf :dialog {label="Faktor mtka kreslen"; width=32;
  : column {
    : spacer {height=1;}
    : row {fixed_width=true; alignment=centered;
      : button {label="Faktor mtka:"; key="b";}
      : edit_box {key="e";}
    }
    : spacer {height=1;}
  }
  ok_cancel;
}

getscl :dialog {label="Zvolte mtko";
  : column {
    : row {
      : boxed_column {label="Architekt";
        : button {label="1/32\"=1'";  key="384";}
        : button {label="1/16\"=1'";  key="192";}
        : button {label="3/32\"=1'";  key="128";}
        : button {label="1/8\"=1'";   key="96";}
        : button {label="3/16\"=1'";  key="64";}
        : button {label="1/4\"=1'";   key="48";}
        : button {label="3/8\"=1'";   key="32";}
        : button {label="1/2\"=1'";   key="24";}
        : button {label="3/4\"=1'";   key="16";}
        : button {label="1\"=1'";     key="12";}
        : button {label="1 1/2\"=1'"; key="8";}
        : button {label="3\"=1'";     key="4";}
        : button {label="1=1";        key="1";}
      }
      : boxed_column {label="Inenr";
        : button {label="1\"=500'"; key="6000";}
        : button {label="1\"=200'"; key="2400";}
        : button {label="1\"=100'"; key="1200";}
        : button {label="1\"=60'";  key="720";}
        : button {label="1\"=50'";  key="600";}
        : button {label="1\"=40'";  key="480";}
        : button {label="1\"=30'";  key="360";}
        : button {label="1\"=20'";  key="240";}
        : button {label="1\"=10'";  key="120";}
        : button {label="1\"=5'";   key="60.0";}
        : button {label="1\"=1'";   key="12.0";}
        : button {label="1=1";  key="1.0";}
      }
      : boxed_column {label="Destkov";
        : button {label="1=500"; key="500";}
        : button {label="1=200"; key="200";}
        : button {label="1=100"; key="100";}
        : button {label="1=60";  key="60";}
        : button {label="1=50";  key="50";}
        : button {label="1=40";  key="40";}
        : button {label="1=30";  key="30";}
        : button {label="1=20";  key="20";}
        : button {label="1=10";  key="10";}
        : button {label="1=5";   key="5";}
        : button {label="1=1";   key="1.00";}
      }
    }
    : row {fixed_width=true; alignment=centered;
      : retirement_button {label="Vybrat objekt"; key="VO";}
      spacer_1;
      cancel_button;
    }
  }
}

