// -----------------------------------------------------------------
// Franz Pltzl           compuserve id 100115,3172
// Hartmanngassse 13/4/36 A-1050 Wien +43 1 5456702
// Robert Kuklovszky, e-mail: kuksi
// -----------------------------------------------------------------
//
// PROFIL.LSP lisp file
// PROFIL.DCL dcl dialog dieses file
// PROFIL.DAT dat file --> profile def.datei
// PROFIL.INI ini file --> benutzereinstellungen
// PROFIL.??? def file --> def. der einzelen profile
//
// rel12/13/14/1.0 0997pf 
//
// -----------------------------------------------------------------

dcl_settings : default_dcl_settings { audit_level = 3; }
//
// deutscher dialog
//
profil_ger : dialog {
   label = "Knihovna vlcovanch profil" ;
   : row {
      children_fixed_height = true ;
      children_fixed_width = true ;
      : boxed_row {
         alignment = top ;
         children_alignment = top ;
         label = "Nhled" ;
         fixed_width = true ;
         fixed_height = true ;
         width = 35;
         height = 11 ;
         : image {
            key = "slide" ;
            width = 28 ;
            height = 11 ;
            color = black ;
         }
      }
      :boxed_row {
         alignment = top ;
         children_alignment = top ;
         fixed_width = true ;
         fixed_height = true ;
         width = 42 ;
         height = 9 ;
         label = "Profil" ;
         : list_box {
            key = "profile" ;
            fixed_width_font = true;    
         }
      }
   }
   : row {
      children_fixed_width = true ;
      children_fixed_width = true ;
      : boxed_column {
         label = "Kreslc jednotky" ;
         children_alignment = left ;
         fixed_width = true ;
         width = 35 ;
         : popup_list {
            key = "einheit" ;
         }
      } 
      : boxed_column {
         label = "Typ profilu" ;
         children_alignment = left ;
         width = 42 ;
         : popup_list {
            key = "typ" ;
            fixed_width_font = true;    
         }
      }
   }
   :row {
      children_fixed_width = true ;
      children_fixed_width = true ;
      : column {
         : boxed_column {
            label = "Bod vloen" ;
            children_alignment = left ;
            fixed_width = true ;
            width = 35 ;
            : popup_list {
               key = "einfpkt" ;
            }
         } 
     : boxed_row {
         label = "Monosti" ;
         width = 20 ;
         : column {
            : toggle {
               key = "spkt" ;
               label = "Tit" ;
               mnemonic = "T" ;
            }
            : toggle {
               key = "mpkt" ;
               label = "Sted smyku" ;
               mnemonic = "S" ;
            }
            : toggle {
               key = "achsen" ;
               label = "Osy" ;
               mnemonic = "O" ;
            }

         }
         : column {   
            : toggle {
               key = "block" ;
               label = "Blok" ;
               mnemonic = "B" ;
            }
            : toggle {
               key = "schraff" ;
               label = "rafovat" ;
               mnemonic = "f" ;
            }
         }
      } //bc
      }//column
      : column {
         : boxed_radio_row {
            width = 42 ;
            label = "Vloit jako" ;
            key = "entity" ;
            : radio_button {
               key = "poly" ;
               label = "Kivku" ;
            }
            : radio_button {
               key = "line" ;
               label = "seky" ;
            }
            : radio_button {
               key = "solid" ;
               label = "Oblast" ;
            }
         }

         : boxed_radio_row {
            width = 42 ;
            label = "Vykreslit" ;
            key = "darst" ;
            : radio_button {
               key = "exakt" ;
               label = "Pesn" ;
            }
            : radio_button {
               key = "einfach" ;
               label = "Schema" ;
            }
            : radio_button {
               key = "grob" ;
               label = "ry" ;
            }
         }

      }//column
   }
   :row {
      children_fixed_height = true ;
      children_fixed_width = true ;
     : boxed_column {
         children_alignment = left ;
         width = 35 ;
         label = "rafy" ;
         : edit_box {
            key = "schraffstil" ;
            label = "Vzor    " ;
            mnemonic = "r" ;
         }
         : edit_box {
            key = "schraffmst" ;
            label = "Mtko " ;
            mnemonic = "M" ;
         }
     }
     : boxed_column {
         children_alignment = left ;
         width = 42 ;
         label = "Orientace" ;
         : edit_box {
            key = "laenge" ;
            label = "Zdvih " ;
            mnemonic = "Z" ;
         }
         : edit_box {
            key = "winkel" ;
            label = "hel   " ;
            mnemonic = "h" ;
         }
      }
//      : boxed_column {
//         children_alignment = left ;
//         label = "Layer" ;
//         width = 42 ;
//         :row { 
//            : button {
//               label = "Profil" ;
//               key = "laprofilb" ;
//               fixed_width = true ;
//               width = 10 ;
//            }
//           : edit_box {
//               key = "laprofilt" ;
//               fixed_width = true ;
//               width = 29 ;
//            }
//         }
//         :row { 
//            : button {
//               label = "Achsen" ;
//               key = "laachsenb" ;
//               fixed_width = true ;
//               width = 10 ;
//            }
//            : edit_box {
//               key = "laachsent" ;
//               fixed_width = true ;
//               width = 29 ;
//            }
//         }  
//    }
   } //row
   ok_cancel_help_info ;
}

////////////////////////////////////////////////////////////////////
//
// english dialog
//
profil_eng : dialog {
   label = "Steel Sections" ;
   : row {
      children_fixed_height = true ;
      children_fixed_width = true ;
      : boxed_row {
         alignment = top ;
         children_alignment = top ;
         label = "Beams" ;
         fixed_width = true ;
         fixed_height = true ;
         width = 35;
         height = 11 ;
         : image {
            key = "slide" ;
            width = 28 ;
            height = 11 ;
            color = black ;
         }
      }
      :boxed_row {
         alignment = top ;
         children_alignment = top ;
         fixed_width = true ;
         fixed_height = true ;
         width = 42 ;
         height = 9 ;
         label = "Beams" ;
         : list_box {
            key = "profile" ;
            fixed_width_font = true;    
         }
      }
   }
   : row {
      children_fixed_width = true ;
      children_fixed_width = true ;
      : boxed_column {
         label = "Unit" ;
         children_alignment = left ;
         fixed_width = true ;
         width = 35 ;
         : popup_list {
            key = "einheit" ;
         }
      } 
      : boxed_column {
         label = "ShapeTyp" ;
         children_alignment = left ;
         width = 42 ;
         : popup_list {
            key = "typ" ;
            fixed_width_font = true;    
         }
      }
   }
   :row {
      children_fixed_width = true ;
      children_fixed_width = true ;
      : column {
         : boxed_column {
            label = "InsertPoint" ;
            children_alignment = left ;
            fixed_width = true ;
            width = 35 ;
            : popup_list {
               key = "einfpkt" ;
            }
         } 
     : boxed_row {
         label = "Optionen" ;
         width = 20 ;
         : column {
            : toggle {
               key = "spkt" ;
               label = "Emphasis" ;
               mnemonic = "S" ;
            }
            : toggle {
               key = "mpkt" ;
               label = "Centre of shear force" ;
               mnemonic = "m" ;
            }
            : toggle {
               key = "achsen" ;
               label = "Axis" ;
               mnemonic = "A" ;
            }

         }
         : column {   
            : toggle {
               key = "block" ;
               label = "Block" ;
               mnemonic = "B" ;
            }
            : toggle {
               key = "schraff" ;
               label = "Hatch" ;
               mnemonic = "r" ;
            }
         }
      } //bc
      }//column
      : column {
         : boxed_radio_row {
            width = 42 ;
            label = "ObjectTyp" ;
            key = "entity" ;
            : radio_button {
               key = "poly" ;
               label = "Polyline" ;
            }
            : radio_button {
               key = "line" ;
               label = "Lines" ;
            }
            : radio_button {
               key = "solid" ;
               label = "Solid" ;
            }
         }

         : boxed_radio_row {
            width = 42 ;
            label = "Detail" ;
            key = "darst" ;
            : radio_button {
               key = "exakt" ;
               label = "Exakt" ;
            }
            : radio_button {
               key = "einfach" ;
               label = "Simplify" ;
            }
            : radio_button {
               key = "grob" ;
               label = "Coarse" ;
            }
         }

      }//column
   }
   :row {
      children_fixed_height = true ;
      children_fixed_width = true ;
     : boxed_column {
         children_alignment = left ;
         width = 35 ;
         label = "Hatch" ;
         : edit_box {
            key = "schraffstil" ;
            label = "HatchStyle" ;
            mnemonic = "S" ;
         }
         : edit_box {
            key = "schraffmst" ;
            label = "HatchScale" ;
            mnemonic = "M" ;
         }
     }
     : boxed_column {
         children_alignment = left ;
         width = 42 ;
         label = "Orientation" ;
         : edit_box {
            key = "laenge" ;
            label = "Thickness" ;
            mnemonic = "L" ;
         }
         : edit_box {
            key = "winkel" ;
            label = "Angle" ;
            mnemonic = "W" ;
         }
      }
//      : boxed_column {
//         children_alignment = left ;
//         label = "Layer" ;
//         width = 42 ;
//         :row { 
//            : button {
//               label = "Section" ;
//               key = "laprofilb" ;
//               fixed_width = true ;
//               width = 10 ;
//            }
//           : edit_box {
//               key = "laprofilt" ;
//               fixed_width = true ;
//               width = 29 ;
//            }
//         }
//         :row { 
//            : button {
//               label = "Achsen" ;
//               key = "laachsenb" ;
//               fixed_width = true ;
//               width = 10 ;
//            }
//            : edit_box {
//               key = "laachsent" ;
//               fixed_width = true ;
//               width = 29 ;
//            }
//         }  
//    }
   } //row
   ok_cancel_help_info ;
}

//
// info list
//
info : dialog {
    label = "Informace o PROFIL";
    key = "info";
    : row {
        : image_button {
            key = "slidei";
            width = 20;
            height = 8;
            aspect_ratio = 1.0;
            fixed_height = true;
            fixed_width = true;
            alignment = top;
            color = dialog_background;
        }
        : column {
            : text {
                key = "text1";
                width = 70;
            }
            : text {
                key = "text2";
                width = 70;
            }
            : text {
                key = "text3";
                width = 70;
            }
            : text {
                key = "text4";
                width = 70;
            }
            : text {
                key = "text5";
                width = 70;
            }
        }
    }
    spacer;
    : list_box {
        width = 64;
        height = 14;
        key = "list";
        fixed_width_font = true;    
    }
    : ok_button {                     // Permit exit via either ENTER
        is_cancel = true;             //   or CTRL-C.
    }
}

