//
//    tcase.dcl
//    Copyright  1998 by Autodesk, Inc.
//
//    Permission to use, copy, modify, and distribute this software
//    for any purpose and without fee is hereby granted, provided
//    that the above copyright notice appears in all copies and
//    that both that copyright notice and the limited warranty and
//    restricted rights notice below appear in all supporting
//    documentation.
//
//    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//    UNINTERRUPTED OR ERROR FREE.
//
//    Use, duplication, or disclosure by the U.S. Government is subject to
//    restrictions set forth in FAR 52.227-19 (Commercial Computer
//    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//    (Rights in Technical Data and Computer Software), as applicable.
//
//  ----------------------------------------------------------------

tcase : dialog {
  label = "TCASE - Zmnit velikost psmen";
  : boxed_column {
   : radio_column {

    : radio_button {
      label = "Vtn skladba.";
      key = "sentence";
      mnemonic = "t";
    }
    : radio_button {
      label = "mal";
      key = "lower";
      mnemonic = "m";
    }
    : radio_button {
      label = "VELK";
      key = "upper";
      mnemonic = "V";
      fixed_width = true;
    }
    : radio_button {
      label = "Prvn Velk";
      key = "title";
      mnemonic = "P";
      fixed_width = true;
    }
    : radio_button {
      label = "zAMNIt.";
      key = "toggle";
      mnemonic = "z";
      fixed_width = true;
    }

   } // radio column
  } // boxed column
  spacer;
  : row
  {
    : button {
      fixed_width=true;
      width=11;
      key="accept";
      is_default=true;
      label= "OK";
    }
    : button {
      fixed_width=true;
      width=11;
      is_cancel=true;
      key="cancel";
      label= "Storno";
    }
    : button {
      fixed_width=true;
      width=11;
      key="help";
      label= "Npo&vda";
      is_help=true;
    }
  } // row
}
