;=======================================================================================
; BTN Better Than Nothing AutoLISP http://home.pacifier.com/~nemi     May 2001
; Create List of layers in the drawing with color and linetype in Excel format
; with csv extension
;=======================================================================================
(defun c:vypishlad (/ nm lnm llnm nam name opf ln lname color ltype lna lnamea colora ltypea)
(setq nm (getvar "dwgname"))
(setq lnm (strlen nm))
(setq llnm (- lnm 3))
(setq nam (substr nm 1 llnm))
(setq name (strcat nam "csv"))
(setq opf (open name "w"))
(setq ln (tblnext "layer" T))
(setq lname (cdr (assoc 2 ln)))
(setq color (cdr (assoc 62 ln)))
(setq ltype (cdr (assoc 6 ln)))
(setq stat (cdr (assoc 70 ln)))
  (cond
      ((= stat 1)(setq state "FROZEN"))
      ((= stat 2)(setq state "FROZEN IN NEW VPORT"))
      ((= stat 4)(setq state "LOCKED"))
      ((< color 0)(setq state "OFF"))
      ((>= color 0)(setq state "ON"))
  ) 
(write-line "Nzev hladiny,Barva,Typ ry,Stav" opf)
(write-line (strcat lname "," (rtos (abs color) 2 0) "," ltype "," state) opf)
  (while
      (setq lna (tblnext "layer"))
      (setq lnamea (cdr (assoc 2 lna)))
      (setq colora (cdr (assoc 62 lna)))
      (setq ltypea (cdr (assoc 6 lna)))
      (setq stata (cdr (assoc 70 lna)))
       (cond
         ((= stata 1)(setq statea "ZMRAZENA"))
         ((= stata 2)(setq statea "ZMRAZENA VE VEZU"))
         ((= stata 4)(setq statea "UZAMENA"))
         ((< colora 0)(setq statea "VYP"))
         ((>= colora 0)(setq statea "ZAP"))
       ) 
      (write-line (strcat lnamea "," (rtos (abs colora) 2 0) "," ltypea "," statea) opf)
  )
(close opf)
(alert (strcat "Soubor " name " byl vytvoen ve sloce Dokumenty"))
(princ)
)
