;cumulative distance
;Don Jacobsen
;Kennewick, WA, USA
;drjcjj@3-cities.com
;this routine is just like the Autocad Distance command with the
;exception that it allows you to pick more than 2 consecutive points.
;the routine will display the cumulative distance and the distance
;between the last two points picked on the command line.
; Tested in 2000 - 08/31/00

(defun c:cd ()
 (setvar "cmdecho" 0)
 (graphscr)
 (setq 
  p1 (getpoint "\nUrete prvn bod: ")
  p2 (getpoint p1 "\nUrete druh bod: ")
  d1 (distance p1 p2)
  prdist (strcat "\nVzdlenost: " (rtos d1))
 )
 (princ prdist)
 (setq p3 (getpoint p2 "\nUrete dal bod nebo ENTER pro dokonen "))
 (while p3
  (setq
   d0 (distance p2 p3)
   d1 (+ (distance p2 p3) d1)
   p2 p3
   prdist (strcat "\nVzdlenost: " (rtos d0) ", Celkov vzdlenost: " (rtos d1))
  )
  (princ prdist)
  (setq p3 (getpoint p2 "\nUrete druh bod "))
 )
 (setq cumd (strcat "Celkov vzdlenost --> " (rtos d1)))
 (prompt cumd)
 (princ)
)
(princ "\nPro sputn nsobn vzdlenosti zadejte pkaz CD")
(princ)
     
