;; Begin code here
;; Written by Lee Ambrosius
;; Created on 3/17/04

;; This routine allows to browse and open a Back or Autosave file in AutoCAD.
(defun c:ExtendedOpen(/ autoSaveFileName)
  (setq autoSaveFileName (getfiled "Vybrat soubor zlohy" (getvar "SAVEFILEPATH") "sv$;bak" 12))

  (if (/= autoSaveFileName nil)
    (progn
      (setq autoSaveFileDwg (strcat (substr autoSaveFileName 1 (- (strlen autoSaveFileName) 3)) "dwg"))
      (if (= (findfile autoSaveFileDwg) nil)
        (vl-file-copy autoSaveFileName autoSaveFileDwg)
	(alert "Soubor nelze pejmenovat pokud existuje vkres se stejnm nzvem.")
      )
      
      (if (findfile autoSaveFileDwg)
        (if (= (getvar "SDI") 0) 
          (progn
	    (setq openedDwg (vla-open (vla-get-documents (vlax-get-acad-object)) autoSaveFileDwg))
	    (vla-put-activedocument (vlax-get-acad-object) openedDwg)
	  )
  	  (command ".open" autoSaveFileDwg)
	)
      )
    )
  )
 (princ)
)
(defun c:EO()(c:ExtendedOpen))
(prompt "Zadejte pkaz ExtendedOpen nebo EO pro oteven zlonch soubor BAK a SV$.")
(princ)
;; End code here
